#ifndef __INBUF_H__
#define __INBUF_H__


struct inbuf {
     char *buf;
     int bufndx;
     int bufsize;
};


#ifndef NOMACROS

#define clearbuf(b) {if((b)->buf)free((b)->buf);(b)->buf=0;\
                     (b)->bufndx=0;(b)->bufsize=0;}

#define resetbuf(b) (b)->bufndx=0

#define addchar(b,c) {\
    if(!(b)->buf){(b)->bufndx=0;(b)->bufsize = 16;(b)->buf = (char *)malloc((b)->bufsize);}\
  if((b)->bufndx == (b)->bufsize){(b)->bufsize <<= 1;(b)->buf = (char *)realloc((b)->buf, (b)->bufsize);}\
  (b)->buf[(b)->bufndx++] = (c);\
}

#define addstr(b,s) {\
    char *___s = (s);\
    if(!(b)->buf){(b)->bufndx=0;(b)->bufsize = 16;(b)->buf = (char *)malloc((b)->bufsize);}\
    for(;*___s;___s++){\
    if((b)->bufndx == (b)->bufsize){(b)->bufsize <<= 1;(b)->buf = (char *)realloc((b)->buf, (b)->bufsize);}\
    (b)->buf[(b)->bufndx++] = *___s;}\
}

#else

extern void clearbuf(struct inbuf *);
extern void resetbuf(struct inbuf *);
extern void addstr(struct inbuf *, char *);
extern void addchar(struct inbuf *, char);

#endif

extern void addstrf(struct inbuf *, char *, char *);

#endif
